## erlang-luerl 0.3

=== Makefile ===
# Copyright (c) 2014 Robert Virding
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
#  limitations under the License.

# Luerl Makefile
# Building from .xrl, .yrl and .erl
# Intermediaries from leex and yecc stay in ./src

SRCDIR        =./src
BEAMDIR       =./ebin
ERL_SOURCES  := $(wildcard $(SRCDIR)/*.erl)
XRL_SOURCES  := $(wildcard $(SRCDIR)/*.xrl)
YRL_SOURCES  := $(wildcard $(SRCDIR)/*.yrl)
ERL_MODULES  := $(ERL_SOURCES:$(SRCDIR)/%.erl=%)
XRL_MODULES  := $(XRL_SOURCES:$(SRCDIR)/%.xrl=%)
YRL_MODULES  := $(YRL_SOURCES:$(SRCDIR)/%.yrl=%)
XRL_INTERM   := $(XRL_MODULES:%=$(SRCDIR)/%.erl)
YRL_INTERM   := $(YRL_MODULES:%=$(SRCDIR)/%.erl)
MODULES      := $(XRL_MODULES) $(YRL_MODULES) $(ERL_MODULES)
OBJECTS      := $(MODULES:%=$(BEAMDIR)/%.beam)

all: $(OBJECTS)

$(BEAMDIR)/%.beam: $(SRCDIR)/%.erl $(SRCDIR)/luerl.hrl
	@ mkdir -p $(BEAMDIR) 
	erlc $(ERLCFLAGS) -o $(BEAMDIR) $<

%.erl: %.xrl
	erlc -o $(SRCDIR) $<

%.erl: %.yrl
	erlc -o $(SRCDIR) $<

clean:
	@ rm -rf $(BEAMDIR)
	@ rm -f *.beam
	@ rm -f erl_crash.dump
	@ rm -f $(XRL_INTERM)
	@ rm -f $(YRL_INTERM)
	$(MAKE) -C examples clean

echo: 
	echo $(OBJECTS) 

examples: all
	$(MAKE) -C examples

debug:
	ERLCFLAGS="+debug_info" make all

.PHONY: all examples clean

# this protects the intermediate .erl files from make's auto deletion
.SECONDARY: $(XRL_INTERM) $(YRL_INTERM)

=== debian/changelog ===
erlang-luerl (1:0.3-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Philipp Huebner <debalance@debian.org>  Thu, 10 May 2018 20:03:31 +0200

erlang-luerl (1:0.3-2) unstable; urgency=medium

  * Ran "cme fix dpkg"
  * Updated Standards-Version: 4.1.4 (no changes needed)

 -- Philipp Huebner <debalance@debian.org>  Wed, 09 May 2018 13:29:07 +0200

erlang-luerl (1:0.3-1) unstable; urgency=medium

  * New upstream version 0.3
  * Whitespace fixes in debian/control
  * Install examples
  * Added debian/watch and increased epoch to follow upstream's versioning
  * Added debian/erlang-luerl.lintian-overrides

 -- Philipp Huebner <debalance@debian.org>  Tue, 06 Mar 2018 18:18:27 +0100

erlang-luerl (0.2015.12.10-5) unstable; urgency=medium

  * Set Maintainer: Ejabberd Packaging Team <ejabberd@packages.debian.org>
  * Set Uploaders: Philipp Huebner <debalance@debian.org>
  * Updated Vcs-* fields in debian/control for salsa.debian.org
  * Updated years in debian/copyright
  * Updated Standards-Version: 4.1.3 (no changes needed)

 -- Philipp Huebner <debalance@debian.org>  Thu, 04 Jan 2018 11:37:45 +0100

erlang-luerl (0.2015.12.10-4) unstable; urgency=medium

  * Updated years in debian/copyright
  * Updated Standards-Version: 4.0.0 (no changes needed)

 -- Philipp Huebner <debalance@debian.org>  Tue, 11 Jul 2017 11:30:02 +0200

erlang-luerl (0.2015.12.10-3) unstable; urgency=medium

  * Added erlang-base to Build-Depends

 -- Philipp Huebner <debalance@debian.org>  Wed, 05 Oct 2016 15:45:29 +0200

erlang-luerl (0.2015.12.10-2) unstable; urgency=medium

  * Build-Depend on erlang-crypto (fixes FTBFS)
  * Updated Standards-Version: 3.9.8 (no changes needed)

 -- Philipp Huebner <debalance@debian.org>  Wed, 07 Sep 2016 11:46:04 +0200

erlang-luerl (0.2015.12.10-1) unstable; urgency=medium

  * Initial release (Closes: #813504)

 -- Philipp Huebner <debalance@debian.org>  Tue, 02 Feb 2016 17:04:03 +0100

=== debian/control ===
Source: erlang-luerl
Maintainer: Ejabberd Packaging Team <ejabberd@packages.debian.org>
Uploaders: Philipp Huebner <debalance@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 11~),
               dh-rebar,
               erlang-base,
               erlang-crypto,
               erlang-eunit,
               erlang-parsetools,
               erlang-syntax-tools
Standards-Version: 4.1.4
Vcs-Browser: https://salsa.debian.org/ejabberd-packaging-team/erlang-luerl
Vcs-Git: https://salsa.debian.org/ejabberd-packaging-team/erlang-luerl.git
Homepage: https://github.com/rvirding/luerl

Package: erlang-luerl
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         erlang-base | ${erlang-abi:Depends},
         ${erlang:Depends}
Description: implementation of Lua in Erlang
 An experimental implementation of Lua 5.2 written solely in pure Erlang
 .
 When to use Luerl:
 .
 Fast Language Switch: Luerl should allow you to switch between Erlang and Lua
 incredibly fast, introducing a way to use very small bits of logic programmed
 in Lua, inside an Erlang application, with good performance.
 .
 Multicore: Luerl provides a way to transparently utilize multicores. The
 underlying Erlang VM takes care of the distribution.
 .
 Microprocesses: It should give you a Lua environment that allows you to
 effortlessly run tens of thousands of Lua processes in parallel, leveraging
 the famed microprocesses implementation of the Erlang VM. The empty Luerl
 State footprint will be yet smaller than the C Lua State footprint.
 .
 Forking Up: Because of the immutable nature of the Luerl VM, it becomes a
 natural operation to use the same Lua State as a starting point for multiple
 parallel calculations.
 .
 However, Luerl will generally run slower than a reasonable native Lua
 implementation. This is mainly due the emulation of mutable data on top of an
 immutable world. There is really no way around this. An alternative would be
 to implement a special Lua memory outside of the normal Erlang, but this would
 defeat the purpose of Luerl. It would instead be then more logical to connect
 to a native Lua.
 .
 Some valid use cases for Luerl are:
  * Lua code will be run only occasionally and it wouldn't be worth managing
    an extra language implementation in the application;
  * the Lua code chunks are small so the slower speed is weighed up by Luerl's
    faster interface;
  * the Lua code calculates and reads variables more than changing them;
  * the same Lua State is repeatedly used to 'fork up' as a basis for
    massively many parallel calculations, based on the same state;
  * it is easy to run multiple instances of Luerl which could better utilise
    multicores.

## erlang-luerl 0.4

=== Makefile ===
# Copyright (c) 2016 Robert Virding
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
#  limitations under the License.

# Makefile for Luerl
# Building from .xrl, .yrl and .erl
# Intermediaries from leex and yecc stay in ./src

SRCDIR        =./src
EBINDIR       =./ebin

ESRCS  := $(notdir $(wildcard $(SRCDIR)/*.erl))
XSRCS  := $(notdir $(wildcard $(SRCDIR)/*.xrl))
YSRCS  := $(notdir $(wildcard $(SRCDIR)/*.yrl))
EBINS = $(ESRCS:.erl=.beam) $(XSRCS:.xrl=.beam) $(YSRCS:.yrl=.beam)

ERLCFLAGS = -W1
ERLC = erlc

all: compile

.PHONY: compile clean echo examples

compile: comp_opts.mk $(addprefix $(EBINDIR)/, $(EBINS))

$(EBINDIR)/%.beam: $(SRCDIR)/%.erl $(SRCDIR)/luerl.hrl comp_opts.mk
	@ mkdir -p $(EBINDIR)
	$(ERLC) $(ERLCFLAGS) -o $(EBINDIR) $(COMP_OPTS) $(ERLCFLAGS) $<

%.erl: %.xrl
	$(ERLC) -o $(SRCDIR) $<

%.erl: %.yrl
	$(ERLC) -o $(SRCDIR) $<

comp_opts.mk:
	escript get_comp_opts.escript

-include comp_opts.mk

clean:
	@ rm -f $(EBINDIR)/*.beam
	@ rm -f *.beam
	@ rm -f erl_crash.dump
	@ rm comp_opts.mk
	$(MAKE) -C examples clean

echo: 
	echo $(OBJECTS) 

examples: all
	$(MAKE) -C examples

debug:
	ERLCFLAGS="+debug_info" make all

.PHONY: all examples clean

# this protects the intermediate .erl files from make's auto deletion
#.SECONDARY: $(XRL_INTERM) $(YRL_INTERM)

=== examples/Makefile ===
SUBDIRS ?= hello

all clean:
	@for subdir in $(SUBDIRS); do					\
	  echo $(MAKE) -C $$subdir $@;					\
	  $(MAKE) -C $$subdir $@;					\
	done

.PHONY: all clean

=== examples/benchmark/Makefile ===
EXAMPLES = benchmarks 

ROOTDIR = ../..
SRCDIR  = $(ROOTDIR)/src
BEAMDIR = $(ROOTDIR)/ebin

all: $(EXAMPLES)

clean:
	rm -f *.beam erl_crash.dump

.SECONDARY:

%.beam: %.erl $(SRCDIR)/*.hrl
	erlc -I $(SRCDIR) $<

%: %.beam
	erl -pa $(BEAMDIR) -s $@ run -s init stop -noshell

.PHONY: all clean

=== debian/changelog ===
erlang-luerl (1:0.4-2) unstable; urgency=medium

  * Updated debhelper compat version: 12
  * Updated Standards-Version: 4.5.0 (no changes needed)
  * Updated years in debian/copyright
  * Rules-Requires-Root: no

 -- Philipp Huebner <debalance@debian.org>  Tue, 04 Feb 2020 21:14:20 +0100

erlang-luerl (1:0.4-1) unstable; urgency=medium

  * New upstream version 0.4
  * Updated Erlang dependencies
  * Enabled DH_VERBOSE in debian/rules
  * Updated years in debian/copyright
  * Updated Standards-Version: 4.4.0 (no changes needed)
  * debian/rules: export ERL_COMPILER_OPTIONS=deterministic
  * Updated debhelper compat version: 12

 -- Philipp Huebner <debalance@debian.org>  Wed, 24 Jul 2019 11:47:23 +0200

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,15 @@
 Uploaders: Philipp Huebner <debalance@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Rules-Requires-Root: no
+Build-Depends: debhelper-compat (= 12),
                dh-rebar,
                erlang-base,
                erlang-crypto,
                erlang-eunit,
                erlang-parsetools,
                erlang-syntax-tools
-Standards-Version: 4.1.4
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/ejabberd-packaging-team/erlang-luerl
 Vcs-Git: https://salsa.debian.org/ejabberd-packaging-team/erlang-luerl.git
 Homepage: https://github.com/rvirding/luerl

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/default.mk
export ERL_COMPILER_OPTIONS=deterministic

%:
	dh $@ --buildsystem=rebar --with rebar

=== debian/watch ===
version=3
opts="filenamemangle=s/.*\/v?(\d\S*)\.tar\.gz/erlang-luerl_$1.tar.gz/" \
  https://github.com/rvirding/luerl/releases .*/v?(\d\S*)\.tar\.gz

## erlang-luerl 0.2015.12.10

=== examples/hello/Makefile ===
EXAMPLES = hello \
	   hello2 \
	   hello_table

ROOTDIR = ../..
SRCDIR  = $(ROOTDIR)/src
BEAMDIR = $(ROOTDIR)/ebin

all: $(EXAMPLES)

clean:
	rm -f *.beam erl_crash.dump

.SECONDARY:

%.beam: %.erl $(SRCDIR)/*.hrl
	erlc -I $(SRCDIR) $<

%: %.beam
	erl -pa $(BEAMDIR) -s $@ run -s init stop -noshell

.PHONY: all clean

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,17 @@
 Source: erlang-luerl
+Section: libs
+Priority: optional
 Maintainer: Ejabberd Packaging Team <ejabberd@packages.debian.org>
 Uploaders: Philipp Huebner <debalance@debian.org>
-Section: libs
-Priority: optional
-Rules-Requires-Root: no
-Build-Depends: debhelper-compat (= 12),
-               dh-rebar,
-               erlang-base,
-               erlang-crypto,
-               erlang-eunit,
-               erlang-parsetools,
-               erlang-syntax-tools
-Standards-Version: 4.5.0
+Build-Depends: debhelper (>= 9), dh-rebar, erlang-base, erlang-crypto, erlang-eunit, erlang-parsetools, erlang-syntax-tools
+Standards-Version: 4.1.3
+Homepage: https://github.com/rvirding/luerl
+Vcs-Git: https://salsa.debian.org/ejabberd-packaging-team/erlang-luerl.git
 Vcs-Browser: https://salsa.debian.org/ejabberd-packaging-team/erlang-luerl
-Vcs-Git: https://salsa.debian.org/ejabberd-packaging-team/erlang-luerl.git
-Homepage: https://github.com/rvirding/luerl
 
 Package: erlang-luerl
 Architecture: any
-Depends: ${shlibs:Depends},
-         ${misc:Depends},
-         erlang-base | ${erlang-abi:Depends},
+Depends: ${shlibs:Depends}, ${misc:Depends}, erlang-base | ${erlang-abi:Depends},
          ${erlang:Depends}
 Description: implementation of Lua in Erlang
  An experimental implementation of Lua 5.2 written solely in pure Erlang
@@ -39,8 +30,8 @@
  the famed microprocesses implementation of the Erlang VM. The empty Luerl
  State footprint will be yet smaller than the C Lua State footprint.
  .
- Forking Up: Because of the immutable nature of the Luerl VM, it becomes a
- natural operation to use the same Lua State as a starting point for multiple
+ Forking Up: Because of the immutable nature of the Luerl VM, it becomes a 
+ natural operation to use the same Lua State as a starting point for multiple 
  parallel calculations.
  .
  However, Luerl will generally run slower than a reasonable native Lua

=== debian/watch ===
# There are no current upstream releases to be tracked

## erlang-luerl 1.0

=== Makefile ===
--- 
+++ 
@@ -29,7 +29,7 @@
 
 all: compile
 
-.PHONY: compile clean echo examples
+.PHONY: all compile clean echo examples debug
 
 compile: comp_opts.mk $(addprefix $(EBINDIR)/, $(EBINS))
 
@@ -43,7 +43,7 @@
 %.erl: %.yrl
 	$(ERLC) -o $(SRCDIR) $<
 
-comp_opts.mk:
+comp_opts.mk: get_comp_opts.escript
 	escript get_comp_opts.escript
 
 -include comp_opts.mk
@@ -64,7 +64,5 @@
 debug:
 	ERLCFLAGS="+debug_info" make all
 
-.PHONY: all examples clean
-
 # this protects the intermediate .erl files from make's auto deletion
 #.SECONDARY: $(XRL_INTERM) $(YRL_INTERM)

=== examples/euler/Makefile ===
EXAMPLES = euler

ROOTDIR = ../..
SRCDIR  = $(ROOTDIR)/src
BEAMDIR = $(ROOTDIR)/ebin

all: $(EXAMPLES)

clean:
	rm -f *.beam erl_crash.dump

.SECONDARY:

%.beam: %.erl $(SRCDIR)/*.hrl
	erlc -I $(SRCDIR) $<

%: %.beam
	erl -pa $(BEAMDIR) -s $@ run -s init stop -noshell

.PHONY: all clean

=== examples/hello/Makefile ===
--- 
+++ 
@@ -1,6 +1,9 @@
 EXAMPLES = hello \
 	   hello2 \
-	   hello_table
+	   hello_table \
+	   hello_table_new \
+	   hello_userdata \
+	   hello_userdata_new
 
 ROOTDIR = ../..
 SRCDIR  = $(ROOTDIR)/src

=== debian/changelog ===
erlang-luerl (1:1.0-2) unstable; urgency=medium

  * Updated debian/watch

 -- Philipp Huebner <debalance@debian.org>  Sat, 18 Dec 2021 11:26:28 +0100

erlang-luerl (1:1.0-1) unstable; urgency=medium

  * New upstream version 1.0
  * Updated Standards-Version: 4.6.0 (no changes needed)
  * Added debian/erlang-luerl.install to install new include/luerl.hrl into
    binary package
  * Added debian/upstream/metadata

 -- Philipp Huebner <debalance@debian.org>  Sun, 29 Aug 2021 18:42:47 +0200

erlang-luerl (1:0.4-5) unstable; urgency=medium

  * Corrected Multi-Arch setting to "allowed"

 -- Philipp Huebner <debalance@debian.org>  Sun, 31 Jan 2021 18:02:27 +0100

erlang-luerl (1:0.4-4) unstable; urgency=medium

  * Added 'Multi-Arch: same' in debian/control
  * Updated years in debian/copyright

 -- Philipp Huebner <debalance@debian.org>  Sat, 30 Jan 2021 16:16:29 +0100

erlang-luerl (1:0.4-3) unstable; urgency=medium

  * Updated Standards-Version: 4.5.1 (no changes needed)
  * Updated version of debian/watch: 4
  * Updated debhelper compat version: 13
  * Updated lintian overrides

 -- Philipp Huebner <debalance@debian.org>  Fri, 25 Dec 2020 21:49:07 +0100

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,28 @@
 Source: erlang-luerl
+Maintainer: Ejabberd Packaging Team <ejabberd@packages.debian.org>
+Uploaders: Philipp Huebner <debalance@debian.org>
 Section: libs
 Priority: optional
-Maintainer: Ejabberd Packaging Team <ejabberd@packages.debian.org>
-Uploaders: Philipp Huebner <debalance@debian.org>
-Build-Depends: debhelper (>= 9), dh-rebar, erlang-base, erlang-crypto, erlang-eunit, erlang-parsetools, erlang-syntax-tools
-Standards-Version: 4.1.3
+Rules-Requires-Root: no
+Build-Depends: debhelper-compat (= 13),
+               dh-rebar,
+               erlang-base,
+               erlang-crypto,
+               erlang-eunit,
+               erlang-parsetools,
+               erlang-syntax-tools
+Standards-Version: 4.6.0
+Vcs-Browser: https://salsa.debian.org/ejabberd-packaging-team/erlang-luerl
+Vcs-Git: https://salsa.debian.org/ejabberd-packaging-team/erlang-luerl.git
 Homepage: https://github.com/rvirding/luerl
-Vcs-Git: https://salsa.debian.org/ejabberd-packaging-team/erlang-luerl.git
-Vcs-Browser: https://salsa.debian.org/ejabberd-packaging-team/erlang-luerl
 
 Package: erlang-luerl
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, erlang-base | ${erlang-abi:Depends},
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         erlang-base | ${erlang-abi:Depends},
          ${erlang:Depends}
+Multi-Arch: allowed
 Description: implementation of Lua in Erlang
  An experimental implementation of Lua 5.2 written solely in pure Erlang
  .
@@ -30,8 +40,8 @@
  the famed microprocesses implementation of the Erlang VM. The empty Luerl
  State footprint will be yet smaller than the C Lua State footprint.
  .
- Forking Up: Because of the immutable nature of the Luerl VM, it becomes a 
- natural operation to use the same Lua State as a starting point for multiple 
+ Forking Up: Because of the immutable nature of the Luerl VM, it becomes a
+ natural operation to use the same Lua State as a starting point for multiple
  parallel calculations.
  .
  However, Luerl will generally run slower than a reasonable native Lua

## erlang-luerl 1.1

=== Makefile ===
--- 
+++ 
@@ -16,16 +16,31 @@
 # Building from .xrl, .yrl and .erl
 # Intermediaries from leex and yecc stay in ./src
 
-SRCDIR        =./src
-EBINDIR       =./ebin
+BINDIR        = ./bin
+EBINDIR       = ./ebin
+SRCDIR        = ./src
 
+LIB = luerl
+
+# To run erl as bash
+FINISH = -run init stop -noshell
+
+# Scripts to be evaluated
+
+GET_VERSION = '{ok,[App]}=file:consult("src/$(LIB).app.src"), \
+	V=proplists:get_value(vsn,element(3,App)), \
+	io:format("~p~n",[V])' \
+	$(FINISH)
+
+
+## The .erl, .xrl, .yrl and .beam files
 ESRCS  := $(notdir $(wildcard $(SRCDIR)/*.erl))
 XSRCS  := $(notdir $(wildcard $(SRCDIR)/*.xrl))
 YSRCS  := $(notdir $(wildcard $(SRCDIR)/*.yrl))
 EBINS = $(ESRCS:.erl=.beam) $(XSRCS:.xrl=.beam) $(YSRCS:.yrl=.beam)
 
 ERLCFLAGS = -W1
-ERLC = erlc
+ERLC ?= erlc
 
 all: compile
 
@@ -55,8 +70,18 @@
 	@ rm comp_opts.mk
 	$(MAKE) -C examples clean
 
+clean-all: clean
+	rm -rf _build
+
 echo: 
 	echo $(OBJECTS) 
+
+get-version:
+	@echo
+	@echo "Getting version info ..."
+	@echo
+	@echo -n app.src: ''
+	@erl -eval $(GET_VERSION)
 
 examples: all
 	$(MAKE) -C examples
@@ -66,3 +91,15 @@
 
 # this protects the intermediate .erl files from make's auto deletion
 #.SECONDARY: $(XRL_INTERM) $(YRL_INTERM)
+
+################
+### RELEASES ###
+################
+
+hex-publish: clean-all compile
+	rebar3 hex publish package
+
+tags:
+	git tag $(shell erl -eval $(GET_VERSION)|tr -d '"')
+	git tag v$(shell erl -eval $(GET_VERSION)|tr -d '"')
+	git push --tags

=== examples/minibench/Makefile ===
EXAMPLES = minibench \
	   minibench2

ROOTDIR = ../..
SRCDIR  = $(ROOTDIR)/src
BEAMDIR = $(ROOTDIR)/ebin

all: $(EXAMPLES)

clean:
	rm -f *.beam erl_crash.dump

.SECONDARY:

%.beam: %.erl $(SRCDIR)/*.hrl
	erlc -I $(SRCDIR) $<

%: %.beam
	erl -pa $(BEAMDIR) -s $@ run -s init stop -noshell

.PHONY: all clean

=== debian/changelog ===
erlang-luerl (1:1.1-1) unstable; urgency=medium

  * New upstream version 1.1
  * Dropped debian/erlang-luerl.install, added debian/source/options and fixed
    debian/rules (closes: #1049485)
  * Updated years in debian/copyright
  * Updated Standards-Version: 4.6.2 (no changes needed)
  * Updated lintian overrides
  * Renamed debian/erlang-luerl.lintian-overrides -> debian/lintian-overrides

 -- Philipp Huebner <debalance@debian.org>  Tue, 26 Dec 2023 15:43:08 +0100

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,13 @@
 Priority: optional
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
-               dh-rebar,
+               dh-rebar (>= 0.0.6),
                erlang-base,
                erlang-crypto,
                erlang-eunit,
                erlang-parsetools,
                erlang-syntax-tools
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/ejabberd-packaging-team/erlang-luerl
 Vcs-Git: https://salsa.debian.org/ejabberd-packaging-team/erlang-luerl.git
 Homepage: https://github.com/rvirding/luerl
@@ -20,7 +20,7 @@
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         erlang-base | ${erlang-abi:Depends},
+         erlang-base, ${erlang-abi:Depends},
          ${erlang:Depends}
 Multi-Arch: allowed
 Description: implementation of Lua in Erlang

=== debian/rules ===
--- 
+++ 
@@ -4,5 +4,22 @@
 include /usr/share/dpkg/default.mk
 export ERL_COMPILER_OPTIONS=deterministic
 
+DESTDIR=$(CURDIR)/debian/erlang-luerl
+
+
 %:
 	dh $@ --buildsystem=rebar --with rebar
+
+
+override_dh_auto_install:
+	dh_auto_install
+	for file in include/*.hrl ; do \
+		fname=$$(basename $${file}) ; \
+		subdir=$$(basename $$(dirname $${file})) ; \
+		if [ ! -f $(DESTDIR)/usr/lib/erlang/lib/luerl-$(DEB_VERSION_UPSTREAM)/$${subdir}/$${fname} ] ; then \
+			install -m 755 -d $(DESTDIR)/usr/lib/erlang/lib/luerl-$(DEB_VERSION_UPSTREAM)/$${subdir} ; \
+			install -m 644 $${file} \
+			$(DESTDIR)/usr/lib/erlang/lib/luerl-$(DEB_VERSION_UPSTREAM)/$${subdir} ; \
+		fi ; \
+	done
+	find $(CURDIR)/debian/tmp/ -type f -name '*.hrl' -delete

=== debian/watch ===
version=4
opts="filenamemangle=s/.*\/v?(\d\S*)\.tar\.gz/erlang-luerl_$1.tar.gz/" \
  https://github.com/rvirding/luerl/tags .*/v?(\d\S*)\.tar\.gz

## erlang-luerl 1.2.0

=== debian/changelog ===
erlang-luerl (1:1.2.0-1) unstable; urgency=medium

  * New upstream version 1.2.0

 -- Philipp Huebner <debalance@debian.org>  Sat, 20 Jul 2024 12:11:44 +0200

## erlang-luerl 1.2.3

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2016 Robert Virding
+# Copyright (c) 2016-2023 Robert Virding
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -44,7 +44,7 @@
 
 all: compile
 
-.PHONY: all compile clean echo examples debug
+.PHONY: all compile clean echo examples debug docs
 
 compile: comp_opts.mk $(addprefix $(EBINDIR)/, $(EBINS))
 
@@ -89,8 +89,110 @@
 debug:
 	ERLCFLAGS="+debug_info" make all
 
+###############
+### TESTING ###
+###############
+
+# XXX for some reason, the first pass of eunit doesn't run the tests?!
+eunit:
+	@rebar3 as test do compile,eunit,eunit
+
+common-test:
+	@rebar3 as test do compile,ct
+
+ct: common-test
+
+tests:
+	@rebar3 as test do compile,eunit,eunit,ct
+
 # this protects the intermediate .erl files from make's auto deletion
 #.SECONDARY: $(XRL_INTERM) $(YRL_INTERM)
+
+#####################
+### DOCUMENTATION ###
+#####################
+
+# Targets for generating docs and man pages
+DOCDIR = doc
+DOCSRC = $(DOCDIR)/src
+MANDIR = $(DOCDIR)/man
+PDFDIR = $(DOCDIR)/pdf
+EPUBDIR = $(DOCDIR)/epub
+MANINSTDIR ?= $(PREFIX)/share/man
+
+MAN1_SRCS = $(notdir $(wildcard $(DOCSRC)/*1.md))
+MAN1S = $(MAN1_SRCS:.1.md=.1)
+TXT1S = $(MAN1_SRCS:.1.md=.txt)
+PDF1S = $(MAN1_SRCS:.1.md=.pdf)
+MAN3_SRCS = $(notdir $(wildcard $(DOCSRC)/*3.md))
+MAN3S = $(MAN3_SRCS:.3.md=.3)
+PDF3S = $(MAN3_SRCS:.3.md=.pdf)
+TXT3S = $(MAN3_SRCS:.3.md=.txt)
+MAN7_SRCS = $(notdir $(wildcard $(DOCSRC)/*7.md))
+MAN7S = $(MAN7_SRCS:.7.md=.7)
+TXT7S = $(MAN7_SRCS:.7.md=.txt)
+PDF7S = $(MAN7_SRCS:.7.md=.pdf)
+
+# For pandoc for generating PDFs as it omly accepts a few options.
+# xelatex is a reasonable default or wkhtmltopdf.
+PANDOCPDF ?= xelatex
+
+# Just generate the docs that are tracked in git
+docs: docs-txt
+
+docs-man: \
+	$(addprefix $(MANDIR)/, $(MAN1S)) \
+	$(addprefix $(MANDIR)/, $(MAN3S)) \
+	$(addprefix $(MANDIR)/, $(MAN7S))
+
+
+$(MANDIR)/%.1: $(DOCSRC)/%.1.md
+	pandoc -f markdown -s -t man -o $@ $<
+
+$(MANDIR)/%.3: $(DOCSRC)/%.3.md
+	pandoc -f markdown -s -t man -o $@ $<
+
+$(MANDIR)/%.7: $(DOCSRC)/%.7.md
+	pandoc -f markdown -s -t man -o $@ $<
+
+clean-docs:
+	rm -f $(DOCDIR)/*.txt $(MANDIR)/*.[0-9] $(PDFDIR)/*.pdf $(EPUBDIR)/*.epub
+
+docs-txt: docs-man \
+	$(addprefix $(DOCDIR)/, $(TXT1S)) \
+	$(addprefix $(DOCDIR)/, $(TXT3S)) \
+	$(addprefix $(DOCDIR)/, $(TXT7S))
+	@if [ -f $(DOCDIR)/luerl_guide.txt ]; then \
+		cp $(DOCDIR)/luerl_guide.txt $(DOCDIR)/user_guide.txt ; \
+	fi
+
+$(DOCDIR)/%.txt: export GROFF_NO_SGR=1
+
+$(DOCDIR)/%.txt: $(MANDIR)/%.1
+	groff -t -e -mandoc -Tutf8 $< | col -bx > $@
+
+$(DOCDIR)/%.txt: $(MANDIR)/%.3
+	groff -t -e -mandoc -Tutf8 $< | col -bx > $@
+
+$(DOCDIR)/%.txt: $(MANDIR)/%.7
+	groff -t -e -mandoc -Tutf8 $< | col -bx > $@
+
+$(PDFDIR):
+	@$(INSTALL_DIR) $(PDFDIR)
+
+docs-pdf: $(PDFDIR) \
+	$(addprefix $(PDFDIR)/, $(PDF1S)) \
+	$(addprefix $(PDFDIR)/, $(PDF3S)) \
+	$(addprefix $(PDFDIR)/, $(PDF7S))
+
+$(PDFDIR)/%.pdf: $(DOCSRC)/%.1.md
+	pandoc -f markdown --pdf-engine=$(PANDOCPDF) -o $@ $<
+
+$(PDFDIR)/%.pdf: $(DOCSRC)/%.3.md
+	pandoc -f markdown --pdf-engine=$(PANDOCPDF) -o $@ $<
+
+$(PDFDIR)/%.pdf: $(DOCSRC)/%.7.md
+	pandoc -f markdown --pdf-engine=$(PANDOCPDF) -o $@ $<
 
 ################
 ### RELEASES ###

=== examples/hello/Makefile ===
--- 
+++ 
@@ -3,7 +3,9 @@
 	   hello_table \
 	   hello_table_new \
 	   hello_userdata \
-	   hello_userdata_new
+	   hello_userdata_new \
+	   hello_sandbox \
+	   hello_funcalls
 
 ROOTDIR = ../..
 SRCDIR  = $(ROOTDIR)/src

=== debian/changelog ===
erlang-luerl (1:1.2.3-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Philipp Huebner <debalance@debian.org>  Fri, 04 Apr 2025 11:56:04 +0200

erlang-luerl (1:1.2.3-1) unstable; urgency=medium

  * New upstream version 1.2.3

 -- Philipp Huebner <debalance@debian.org>  Thu, 03 Oct 2024 17:10:27 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Priority: optional
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
-               dh-rebar (>= 0.0.6),
+               dh-rebar (>= 0.0.6~),
                erlang-base,
                erlang-crypto,
                erlang-eunit,
